﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class CellPhone : MonoBehaviour {

	public Button button;
	public Image buttonImage;
	public Text buttonImageText;

	private Vector3 targetPosition;
	private Vector3 targetRotation;

	private Vector3 originPosition;
	private Vector3 originRotation;
	private Vector3 cameraOriginRotation;

	private float timeStart;
	private float timeDuration = 4;
	private int state = 0;

	public GameObject targerForPhone;
	public GameObject objPlayer;
	public GameObject objCamera;
	public Text phoneText;
	public GameObject objHelloAgain;
	private bool helloState = true;

	public Light phoneScreen;

	void Awake() {
		originPosition = transform.position;
		originRotation = transform.eulerAngles;
	}

	public void ButtonPressed () {
		button.enabled=false;
		buttonImage.enabled=false;
		buttonImageText.enabled=false;
		state = 1;
		timeStart = Time.time;
		objPlayer.SendMessage("WatchMode");
		cameraOriginRotation = objCamera.transform.eulerAngles;
		audio.Stop();
	}

	void Update() {
		targetPosition = new Vector3(targerForPhone.transform.position.x, targerForPhone.transform.position.y, targerForPhone.transform.position.z);
		targetRotation = new Vector3(targerForPhone.transform.eulerAngles.x + 360f, targerForPhone.transform.eulerAngles.y +90f, 90f);

		if (state == 1)
		{
			if (Time.time - timeStart < timeDuration)
			{
				transform.position =  Vector3.Lerp(originPosition, targetPosition, (Time.time - timeStart) / timeDuration);
				transform.eulerAngles =  Vector3.Lerp(originRotation, targetRotation, (Time.time - timeStart) / timeDuration);
				objCamera.transform.eulerAngles = Vector3.Lerp(cameraOriginRotation, new Vector3(0, cameraOriginRotation.y, cameraOriginRotation.z), (Time.time - timeStart) / timeDuration);
			}
			else
			{
				transform.position = targetPosition;
				transform.eulerAngles = targetRotation;
				if (helloState)
				{
					helloState = false;
					objHelloAgain.SendMessage("MusicEnable");
				}
			}				

			if ((Time.time - timeStart > timeDuration + 2) && (Time.time - timeStart < timeDuration + 5))
			{
				phoneText.text = "Good news\nWe can be together\nforever";
			}

			if (Time.time - timeStart > timeDuration + 5)
			{
				phoneText.text = "one game\none screen\none life\nand game is over";
			}
		}
		if (buttonImage.enabled)
		{
			buttonImage.color = Color.Lerp(Color.blue, Color.white, 0.5f + Mathf.Sin(Time.time * 10)/2);
			phoneScreen.intensity = Mathf.Lerp(0, 2, 0.5f + Mathf.Sin(Time.time * 10)/2);
		}
	}
}
