﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class GameController : MonoBehaviour {

	private int gameProgress = 0;

	public Button theButton;
	private float theButtonPositionY;

	public Slider progressBar;
	private float progressBarPositionY;
	private float progress = 50;
	private float progressMax = 100;
	private float progressMin = 0;
	private float progressStart;
	private float progressDelta;
	private float timeUpMax = 2;
	private float timeUp;
	private float timeDown = 4;
	private float timeStart;

	private int progressState = 0;

	public Text currentRule;

	public Slider filler1;
	private float filler1positionY;
	private float filler1Max = 200;
	private float filler1Min = 1;
	private float convertRation = 1;

	public Text upgradeSelect1Text;
	public Text upgradeSelect2Text;
	public Text upgradeSelect3Text;

	public Image Upgrades;
	public Vector3 UpgradesPosition;


	private int upgrade1=0;
	private int upgrade2=0;
	private int specialUpgrade=0;
	public Text progressBarNumbers;
	public Text filler1Numbers;

	public Image BackgroundImage;
	public Sprite newBackground;

	public GameObject MusicController;
	public GameObject ObjPlayer;
	private int walkMode = 0;

	public Text levelText;

	public Image welcomeScreen;
	private float welcomeScreenTimer;
	public Sprite comebackScreen;
	public GameObject monitor;


	void Awake () {
		timeStart = Time.time;
		progressStart = 50;
		progressBar.maxValue = progressMax;
		filler1.maxValue = filler1Max;
		levelText.enabled=false;
		
		//Original coordinates of UI elements (i want to hide them by moving in another distant place)
		theButtonPositionY = theButton.transform.localPosition.y;
		progressBarPositionY = progressBar.transform.localPosition.y;
		filler1positionY = filler1.transform.localPosition.y;

		//Hide some UI on start
		HideAndShow ("First filler", true);
		HideAndShow ("Upgrade buttons", true);

		progressBarNumbers.enabled=false;
		filler1Numbers.enabled=false;

		welcomeScreenTimer = Time.time;
	}

	void HideAndShow (string hideObjects, bool hide) {
		if (hideObjects == "Main Button and Progress Bar")
		{
			if (hide)
			{
				theButton.transform.localPosition = new Vector3(theButton.transform.localPosition.x, -1000, theButton.transform.localPosition.z);
				progressBar.transform.localPosition = new Vector3(progressBar.transform.localPosition.x, -1000, progressBar.transform.localPosition.z);
			}
			else
			{
				theButton.transform.localPosition = new Vector3(theButton.transform.localPosition.x, theButtonPositionY, theButton.transform.localPosition.z);
				progressBar.transform.localPosition = new Vector3(progressBar.transform.localPosition.x, progressBarPositionY, progressBar.transform.localPosition.z);
			}
		}

		if (hideObjects == "First filler")
		{
			if (hide)
			{
				filler1.transform.localPosition = new Vector3(filler1.transform.localPosition.x, -1000, filler1.transform.localPosition.z);
			}
			else
			{
				filler1.transform.localPosition = new Vector3(filler1.transform.localPosition.x, filler1positionY, filler1.transform.localPosition.z);
			}
		}

		if (hideObjects == "Upgrade buttons")
		{
			if (hide)
			{
				Upgrades.transform.localPosition = new Vector3(Upgrades.transform.localPosition.x, -1000, Upgrades.transform.localPosition.y);			}
			else
			{
				Upgrades.transform.localPosition = UpgradesPosition;
			}
		}

	}

	public void UpgradeSelected (int upgradeButton) {
		switch (upgradeButton)
		{
			case 1:
			{				
				switch (upgrade1)
				{
					case 0:
					{
						timeUpMax = timeUpMax * 0.6f;
						upgrade1 = 1;
						monitor.SendMessage("Say","sweet");
					}
					break;
			
					case 1:
					{					
						progressMax = progressMax * 1.3f;
						progressBar.maxValue = progressMax;
						if (progressBar.transform.localScale.x < 1.35f) 
						 	progressBar.transform.localScale = new Vector3(progressBar.transform.localScale.x * 1.1f, progressBar.transform.localScale.y* 1.1f, progressBar.transform.localScale.z);
						upgrade1 = 0;
						monitor.SendMessage("Say","excellent");
					}
					break;
				}
			}
			break;

			case 2:
			{
				switch (upgrade2)
					{
					case 0:
					{
						convertRation = convertRation * 1.15f;
						upgrade2 = 1;
						monitor.SendMessage("Say","wise");
					}
					break;
				
					case 1:
					{			
						timeDown = timeDown * 0.8f;
						upgrade2 = 0;
						monitor.SendMessage("Say","good");
					}
					break;
				}
			}
			break;
				
			case 3:
			{
				switch (specialUpgrade)
				{
					case 0:
					{
					    progressBarNumbers.enabled=true;
						filler1Numbers.enabled=true;
						specialUpgrade = 1;
						monitor.SendMessage("Say","numbers");
					}
					break;

					case 1:
					{
						BackgroundImage.sprite=newBackground;
						BackgroundImage.color=Color.white;
						currentRule.color = Color.black;
						levelText.color=Color.black;
						specialUpgrade = 2;
						monitor.SendMessage("Say","picture");
					}
					break;

					case 2:
					{
						MusicController.SendMessage("MusicEnable");
						specialUpgrade = 3;
						monitor.SendMessage("Say","music");
					}
					break;

					case 3:
					{
						currentRule.text = "Rules:\n1.Do meaningless things\n2.Have no fun\n3.Never press S on keyboard";
						specialUpgrade = 4;
					}
					break;

					case 4:
					{
						filler1Max=filler1Max * 0.75f;
						filler1.maxValue = filler1Max;
						monitor.SendMessage("Say","oh_yeah");
					}
					break;
			}
		}
			break;
		}

		HideAndShow ("Main Button and Progress Bar", false);
		HideAndShow ("First filler", false);
		HideAndShow ("Upgrade buttons", true);

		if (gameProgress==2)
		{
			monitor.SendMessage("Say","rule4");
			currentRule.text = currentRule.text + "\n4. Repeat";
		}
	}
	
	public void ButtonPressed () {
		if (progressState == 0)
		{
			progressState = 1;
			progressStart = progress;
			timeStart = Time.time;
			timeUp = timeUpMax - timeUpMax * (progressStart / progressMax); 

			if (walkMode == 1)
			{
				switch (Mathf.RoundToInt(Random.Range(1f,4f)))
				{
					case 1: monitor.SendMessage("Say","stillClicking1"); break;
					case 2: monitor.SendMessage("Say","stillClicking2"); break;
					case 3: monitor.SendMessage("Say","stillClicking3"); break;
					case 4: monitor.SendMessage("Say","stillClicking4"); break;
				}
			}
		}
	}


	void Update () {
		if (progressState == 1)
		{
			progress=Mathf.Lerp(progressStart, progressMax, (Time.time - timeStart)/timeUp);
			if (progress >= progressMax)
			{
				progress = progressMax;
				progressStart = progress;
				progressState = 0;
				timeStart = Time.time;
				if (gameProgress == 0)
				{
					gameProgress = 1;
					monitor.SendMessage("Say","rule2");
					currentRule.text += "\n2. Fill the red line";
					HideAndShow ("First filler", false);
				}
			}
		}
		else
		{
			if (Time.time - timeStart <= timeDown)
			{
				progressDelta = progress;
				progress=Mathf.Lerp(progressStart, progressMin, (Time.time - timeStart)/timeDown);
				progressDelta -= progress;
				if (gameProgress > 0)
				{
					if (filler1.value < filler1Max)
					{
						filler1.value += progressDelta * convertRation;
						filler1Numbers.text = Mathf.RoundToInt(filler1.value).ToString() + "/" + Mathf.RoundToInt(filler1Max).ToString();
					}
					else
					{
						filler1.value = filler1Min;
						progress = progressMin;
						gameProgress+=1;
						filler1Max+=50;
						filler1.maxValue = filler1Max;
						levelText.text = "Level: " + gameProgress.ToString();
						if (gameProgress==2)
						{
							monitor.SendMessage("Say","rule3");
							currentRule.text += "\n3. Choose the reward";
							levelText.enabled=true;
						}

						HideAndShow ("Main Button and Progress Bar", true);
						HideAndShow ("First filler", true);
						HideAndShow ("Upgrade buttons", false);

						switch (upgrade1)
						{
							case 0: upgradeSelect1Text.text = "Fill speed (+40%)"; break;
							case 1: upgradeSelect1Text.text = "Enlarge green line (+30%)"; break;
						}

						switch (upgrade2)
						{
							case 0: upgradeSelect2Text.text = "Rapid decrease (+20%)"; break;
							case 1: upgradeSelect2Text.text = "Increase convert green to red (+15%)"; break;
						}
						
						switch (specialUpgrade)
						{
							case 0: upgradeSelect3Text.text = "Show numbers"; break;
							case 1: upgradeSelect3Text.text = "Change background"; break;
							case 2: upgradeSelect3Text.text = "Enable music"; break;
							case 3: upgradeSelect3Text.text = "Real rules"; break;
							default: upgradeSelect3Text.text = "Cut red bar by 25%"; break;
						}
					}
				}
			}
		}
		progressBar.value = progress;
		progressBarNumbers.text = Mathf.RoundToInt(progressBar.value).ToString() + "/" + Mathf.RoundToInt(progressMax).ToString();

		if (Input.GetKeyDown("s") && specialUpgrade == 4 && walkMode == 0)
		{
			ObjPlayer.SendMessage("WalkMode");
			walkMode = 1;
			currentRule.text += "\n4. What are you doing?";
			monitor.SendMessage("Say","whatAreYouDoing");
		}

        //Welcome screen
		if (Time.time - welcomeScreenTimer > 3f && Time.time - welcomeScreenTimer < 4f && welcomeScreen.enabled)
		{
			welcomeScreen.transform.localScale=new Vector3(Mathf.Lerp(1,0, Time.time - welcomeScreenTimer - 3f / 1f), Mathf.Lerp(1,0, Time.time - welcomeScreenTimer - 3f / 1f), 1f);
		}
		if (Time.time - welcomeScreenTimer > 4f && welcomeScreen.enabled)
		{
			welcomeScreen.enabled = false;
			welcomeScreen.sprite = comebackScreen;
			welcomeScreen.transform.localScale=new Vector3 (1f, 1f, 1f);
		}

		if (Vector3.Distance(ObjPlayer.transform.position, transform.position) > 2.5f)
		{
			welcomeScreen.enabled = true;			
		}
		else
		{
			if (walkMode == 1)
				welcomeScreen.enabled = false;
		}
	}
}
