﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class PlayerController : MonoBehaviour {

	public GameObject objCamera;
	private Camera camCamera;
	public Image pointer;
	public GameObject objMonitor;

	void Awake() {
		pointer.enabled = false;
	}

	public void WalkMode() {
		gameObject.SendMessage("Activate");
		objCamera.SendMessage("Activate");
		Screen.lockCursor = true;
		pointer.enabled = true;
		camCamera = objCamera.GetComponent<Camera>();
		camCamera.fieldOfView = 60;
	}

	public void WatchMode() {
		gameObject.SendMessage("Deactivate");
		objCamera.SendMessage("Deactivate");
		pointer.enabled = false;
		Screen.lockCursor = false;
	}
	void Update() {
		if (Vector3.Distance(transform.position, objMonitor.transform.position) < 20f)
			audio.volume = 0;
		if (Vector3.Distance(transform.position, objMonitor.transform.position) > 20f && Vector3.Distance(transform.position, objMonitor.transform.position) <50f)
			audio.volume = Mathf.Lerp(0, 0.2f, (Vector3.Distance(transform.position, objMonitor.transform.position) - 20f) / 30f);
		if (Vector3.Distance(transform.position, objMonitor.transform.position) > 100f)
			audio.volume = 0.2f;

	}
}
